<template>
    <paginator-wrap :count="resultCount" :limit-count="pageLimit" :current="paginationPage"
        @change:limit="changePageLimitHandler" @change:current="changeCurrentPageHandler"
    >
        <template v-slot:filter>
            <component :is="currentFilterComponent"></component>
        </template>
        <template v-slot:table>
            <users-table :data="tableData" :table-structure="tableStructure" :sort-params="sortSetting" @sort-change="sortHandler"
            :highlightCurrentRow="highlightCurrentRow" />
        </template>
    </paginator-wrap>
</template>

<script>
import { usersTable } from '@/constants/ui/listings';
import { PaginatorWrap } from '@bloomio/spa-admin-common/components';
import {
    UsersFilterForm, InvestorsFilterForm, StartupsFilterForm, ExpertsFilterForm, SubscribersFilterForm,
} from '@/components/forms/FilterForm';
import UsersTable from '@/components/tables/UsersTable';
import listingMixin from '@/mixins/listingMixin';
import {
    mapActions, mapGetters, mapMutations, mapState,
} from 'vuex';

export default {
    components: {
        UsersTable,
        PaginatorWrap,
        UsersFilterForm,
        InvestorsFilterForm,
        StartupsFilterForm,
        ExpertsFilterForm,
        SubscribersFilterForm,
    },
    mixins: [listingMixin],
    data() {
        return {
            highlightCurrentRow: true,
        };
    },
    computed: {
        tableStructure: () => ({ ...usersTable }),
        ...mapState({
            tableData: state => state.users.all_users,
            serverFilter: state => state.users.users_filter,
            serverSorting: state => state.users.all_users_sorting,
        }),
        ...mapGetters({
            resultCount: 'allUsersTotal',
            paginationPage: 'allUsersCurrentPage',
            pageLimit: 'allUsersPageLimit',
        }),
    },
    methods: {
        /** import methods from vuex actions */
        ...mapActions({
            changeSorting: 'changeUsersSorting',
            changePage: 'changeUsersPage',
            getList: 'getUsersList',
        }),
        /** import methods from vuex mutations */
        ...mapMutations({
            setPageLimit: 'setUsersPageLimit',
            setCurrentPage: 'setUsersCurrentPage',
        }),
    },
};
</script>
